# stripchart - tools for quick and dirty data plotting.
#
# Copyright (C) 2008-2009 William Trevor King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# The author may be contacted at <wking@drexel.edu> on the Internet, or
# write to Trevor King, Drexel University, Physics Dept., 3141 Chestnut St.,
# Philadelphia PA 19104, USA.

import os

class stripchart :
    def __init__(self, pipename='strip_pipe', maxY=10, minY=-10,
                 npoints=100, title='chart', axes=True) :
        self.pipename = pipename
        self.maxY = maxY
        self.minY = minY
        self.npoints = npoints
        self.title = title
        self.axes = axes
        self.status = 'closed'
        self.pipe = None
    def __del__(self) :
        self.close()
    def open(self, debug=False) :
        if self.status == 'closed' :
            os.mkfifo(self.pipename)
            cmd = "stripchart -t '%s' -p '%s' -u -M '%g' -m '%g' -n '%d'" % \
                (self.title, self.pipename, self.maxY, self.minY,
                 self.npoints)
            if self.axes == False :
                cmd += " -a"
            cmd += " &"
            if debug :
                print cmd
            os.system(cmd)
            self.pipe = open(self.pipename,'w')
            self.status = 'open'
    def close(self) :
        if self.status == 'open' :
            print >> self.pipe, "q"
            self.pipe.close()
            self.pipe = None
            self.status = 'closed'
    def _add_point(self, point) :
        print >> self.pipe, point
    def _flush(self) :
        self.pipe.flush()
    def add_point(self, point) :
        self._add_point(point)
        self._flush()
